SystemOrganization addCategory: #WorkPlayRatioScheduler!

Object subclass: #WorkPlayRatioScheduler
	instanceVariableNames: 'workMin workPerPlayRatio mins schedule tempBisectVar'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WorkPlayRatioScheduler'!

!WorkPlayRatioScheduler classSide methodsFor: 'example' stamp: 'HwaJong 12/18/2012 13:05'!
outputScheduleForm
|s|
s := WorkPlayRatioScheduler new.
s workUpTo: (Time hour: 23 minute: 0 second: 0).
s workPerPlayRatio: 9/3.
s workMin: 1.
s compute. 
s schedule explore.
s openForm.
s saveFormToPNGName: '/Users/daliot/Desktop/print.png'.! !

!WorkPlayRatioScheduler classSide methodsFor: 'example' stamp: 'HwaJong 11/23/2012 15:02'!
ratio4hour4
|s|
s := WorkPlayRatioScheduler new.
s hours: 4.
s workPerPlayRatio: 4.
s workMin: 1.
s compute. 
^s schedule! !

!WorkPlayRatioScheduler classSide methodsFor: 'example' stamp: 'HwaJong 11/23/2012 15:03'!
ratio5hour8
|s|
s := WorkPlayRatioScheduler new.
s hours: 8.
s workPerPlayRatio: 5.
s workMin: 1.
s compute. 
^s schedule! !

!WorkPlayRatioScheduler classSide methodsFor: 'example' stamp: 'HwaJong 11/27/2012 10:55'!
work5play3upto9pm
|s|
s := WorkPlayRatioScheduler new.
s workUpTo: (Time hour: 21 minute: 0 second: 0).
s workPerPlayRatio: 5/3.
s workMin: 1.
s compute. 
^s schedule.

! !

!WorkPlayRatioScheduler methodsFor: 'adding' stamp: 'HwaJong 11/23/2012 14:56'!
addEntryToSchedule
schedule addLast: self workPlayEntry! !

!WorkPlayRatioScheduler methodsFor: 'changing' stamp: 'HwaJong 11/23/2012 15:00'!
compute
[self addEntryToSchedule.
self reduceMin.
mins > 0]
	whileTrue:
		[self increaseWorkMin].! !

!WorkPlayRatioScheduler methodsFor: 'accessing' stamp: 'HwaJong 11/23/2012 14:58'!
hours: anInteger
self mins: anInteger * 60! !

!WorkPlayRatioScheduler methodsFor: 'changing' stamp: 'HwaJong 11/23/2012 14:50'!
increaseWorkMin
workMin := workMin + 1! !

!WorkPlayRatioScheduler methodsFor: 'initialize-release' stamp: 'HwaJong 12/27/2012 10:19'!
initialize 
super initialize.
schedule := OrderedCollection new.! !

!WorkPlayRatioScheduler methodsFor: 'accessing' stamp: 'HwaJong 11/23/2012 14:58'!
mins: anInteger
mins := anInteger! !

!WorkPlayRatioScheduler methodsFor: 'form' stamp: 'HwaJong 12/18/2012 12:54'!
openForm
	self scheduleForm asMorph openInWindowLabeled: 'Schedule'! !

!WorkPlayRatioScheduler methodsFor: 'evaluating' stamp: 'HwaJong 11/23/2012 14:48'!
playMin
^(workMin / workPerPlayRatio) rounded max: 1! !

!WorkPlayRatioScheduler methodsFor: 'changing' stamp: 'HwaJong 11/23/2012 14:50'!
reduceMin
mins := mins - workMin - self playMin.! !

!WorkPlayRatioScheduler methodsFor: 'form' stamp: 'HwaJong 12/18/2012 12:53'!
saveFormToPNGName: aString 
	PNGReadWriter putForm: self scheduleForm onFileNamed: aString! !

!WorkPlayRatioScheduler methodsFor: 'accessing' stamp: 'HwaJong 11/23/2012 15:00'!
schedule
	^ schedule! !

!WorkPlayRatioScheduler methodsFor: 'form' stamp: 'HwaJong 12/27/2012 10:19'!
scheduleForm
	| rowHeight form canvas bottomY |
	rowHeight := 15.
	form := Form extent: ((300)@(rowHeight * (schedule size + 1))) depth: 1.
	bottomY := form height - 25.
	canvas := FormCanvas on: form.
	canvas fillColor: Color white.
	canvas line: (10@rowHeight) to: ((300-10)@rowHeight) color: Color black.
	canvas line: (150@0) to: (150@bottomY) color: Color black.
	canvas line: (75@0) to: (75@bottomY) color: Color black.
	canvas line: (225@0) to: (225@bottomY) color: Color black.
	canvas drawString: 'Work' at: 25@0.
	canvas drawString: 'Play' at: 102@0.
	canvas drawString: 'Work' at: 174@0.
	canvas drawString: 'Play' at: 247@0.
	
	(1 to: (schedule size min: 20)) do: [:index| |pair|
		pair := schedule at: index.
		canvas drawString: pair first printString at: 32@(index * 19).
		canvas drawString: pair second printString at: 111@(index * 19).
		].
	((schedule size min: 21) to: (schedule size)) do: [:index| | pair dIndex |
		dIndex := index - 20.
		pair := schedule at: index.
		canvas drawString: pair first printString at: 181@(dIndex * 19).
		canvas drawString: pair second printString at: 255@(dIndex * 19).
		].
	canvas drawString: Date today printString at: 90@(bottomY+7).
	^form! !

!WorkPlayRatioScheduler methodsFor: 'accessing' stamp: 'HwaJong 11/23/2012 14:57'!
workMin
	^ workMin! !

!WorkPlayRatioScheduler methodsFor: 'accessing' stamp: 'HwaJong 11/23/2012 14:57'!
workMin: anInteger
	workMin := anInteger
! !

!WorkPlayRatioScheduler methodsFor: 'accessing' stamp: 'HwaJong 11/23/2012 14:57'!
workPerPlayRatio
	^ workPerPlayRatio! !

!WorkPlayRatioScheduler methodsFor: 'accessing' stamp: 'HwaJong 11/23/2012 14:57'!
workPerPlayRatio: aNumber
	workPerPlayRatio := aNumber
! !

!WorkPlayRatioScheduler methodsFor: 'evaluating' stamp: 'HwaJong 11/23/2012 14:49'!
workPlayEntry
^{workMin . self playMin}! !

!WorkPlayRatioScheduler methodsFor: 'express access' stamp: 'HwaJong 11/27/2012 10:49'!
workUpTo: aTime 

	self mins: (((aTime asSeconds - Time now asSeconds) / 60) truncated - (60*3)).! !
